//+------------------------------------------------------------------+
//|                                                Multi pair MA.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property  indicator_buffers 5
#property indicator_minimum  0
#property indicator_color1   Lime
#property indicator_color2   LimeGreen
#property indicator_color3   Gold
#property indicator_color4   Orange
#property indicator_color5   Red

//
//
//
//
//

extern string    pairs          = "EURUSD;GBPUSD;USDCAD";
extern int       barsPerPair    =    70;
extern int       maPeriod.1     =    14;
extern int       maPrice.1      = PRICE_CLOSE;
extern int       maMethod.1     = MODE_EMA;
extern int       maPeriod.2     =    20;
extern int       maPrice.2      = PRICE_CLOSE;
extern int       maMethod.2     = MODE_EMA;
extern int       maPeriod.3     =    30;
extern int       maPrice.3      = PRICE_CLOSE;
extern int       maMethod.3     = MODE_EMA;
extern int       maPeriod.4     =    50;
extern int       maPrice.4      = PRICE_CLOSE;
extern int       maMethod.4     = MODE_EMA;
extern int       maPeriod.5     =    80;
extern int       maPrice.5      = PRICE_CLOSE;
extern int       maMethod.5     = MODE_EMA;
extern string    _              = "other";
extern string    text           = "color";
extern color     textColor      = Silver;
extern color     backColor      = C'48,48,48';
extern int       separatorWidth = 6;

//
//
//
//
//

double ma1[];
double ma2[];
double ma3[];
double ma4[];
double ma5[];

//
//
//
//
//

string   aPairs[];
string   shortName;
string   indicatorFileName;
int      window;  



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   SetIndexBuffer(0,ma1);
   SetIndexBuffer(1,ma2);
   SetIndexBuffer(2,ma3);
   SetIndexBuffer(3,ma4);
   SetIndexBuffer(4,ma5);

   //
   //
   //
   //
   //

      pairs = StringUpperCase(StringTrimLeft(StringTrimRight(pairs)));
      if (StringSubstr(pairs,StringLen(pairs),1) != ";")
                       pairs = StringConcatenate(pairs,";");
              
         //
         //
         //
         //
         //                                   
         
         
         int s =  0;
         int i =  StringFind(pairs,";",s);
         string current;
         string temp;
            while (i >= 0)
            {
               if (IsMini())
                     current = StringSubstr(pairs,s,i-s)+"m";
               else  current = StringSubstr(pairs,s,i-s);
               
               //
               //
               //
               //
               //

               if (current == ";") current = Symbol();
               if (iClose(current,0,0) > 0)
                  {
                     ArrayResize(aPairs,ArraySize(aPairs)+1);
                                 aPairs[ArraySize(aPairs)-1] = current;
                                 if (current == Symbol())
                                 {
                                       temp      = aPairs[0];
                                       aPairs[0] = current;
                                       aPairs[ArraySize(aPairs)-1] = temp;
                                 }                                       
                  }
                  s = i + 1;
                  i = StringFind(pairs,";",s);
            }

   //
   //
   //
   //
   //
 
      indicatorFileName = WindowExpertName();
      separatorWidth    = MathMax(separatorWidth,4);
      shortName         = MakeUniqueName("Multi MA ","");
      IndicatorShortName(shortName);
 
   //
   //
   //
   //
   //
   
   return(0);
}

int deinit()
{
   for (int i = 0; i < ArraySize(aPairs); i++) { 
         ObjectDelete(shortName+i);
         ObjectDelete(shortName+i+i);
      }         
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int    limit = ArraySize(aPairs);
   int    i,k;
   
         window = WindowFind(shortName);  
         k = 0; for (i=0; i<limit; i++) calculateMAs(aPairs[i],barsPerPair,k,i);

   //
   //
   //
   //
   //

   for (i=0;i<6;i++) SetIndexDrawBegin(i,Bars-k);
   return(0);
}


//+------------------------------------------------------------------+
//+                                                                  +
//+------------------------------------------------------------------+
//
//
//
//
//

void calculateMAs(string symbol,int limit,int& shift,int element)
{
   double min = EMPTY_VALUE;
   double max = EMPTY_VALUE;
   for(int i=0; i<limit; i++)
   {
      doCalculate(ma1,symbol,maPeriod.1,maPrice.1,maMethod.1,min,max,i,shift);
      doCalculate(ma2,symbol,maPeriod.2,maPrice.2,maMethod.2,min,max,i,shift);
      doCalculate(ma3,symbol,maPeriod.3,maPrice.3,maMethod.3,min,max,i,shift);
      doCalculate(ma4,symbol,maPeriod.4,maPrice.4,maMethod.4,min,max,i,shift);
      doCalculate(ma5,symbol,maPeriod.5,maPrice.5,maMethod.5,min,max,i,shift);
   }
   for(i=0; i<limit; i++)
   {
      if (min==max) max+= Point;
      if (ma1[i] != EMPTY_VALUE) ma1[i+shift] = (ma1[i+shift]-min)/(max-min);
      if (ma2[i] != EMPTY_VALUE) ma2[i+shift] = (ma2[i+shift]-min)/(max-min);
      if (ma3[i] != EMPTY_VALUE) ma3[i+shift] = (ma3[i+shift]-min)/(max-min);
      if (ma4[i] != EMPTY_VALUE) ma4[i+shift] = (ma4[i+shift]-min)/(max-min);
      if (ma5[i] != EMPTY_VALUE) ma5[i+shift] = (ma5[i+shift]-min)/(max-min);
   }
   for (i=0;i<separatorWidth;i++)
   {
         ma1[shift+limit+i] = EMPTY_VALUE;                     
         ma2[shift+limit+i] = EMPTY_VALUE;                     
         ma3[shift+limit+i] = EMPTY_VALUE;                     
         ma4[shift+limit+i] = EMPTY_VALUE;                     
         ma5[shift+limit+i] = EMPTY_VALUE;
      }         

   //
   //
   //
   //
   //
   
   createLabel(symbol,element,shift+limit+separatorWidth-2,false);
   shift += limit+separatorWidth-1;
}

//
//
//
//
//

void doCalculate(double &ma[], string symbol, int period, int price, int method, double &min, double &max, int i,int shift)
{
   if (period>1)
   {
      ma[i+shift] = iMA(symbol,0,period,0,method,price,i);
         if (min == EMPTY_VALUE) min = ma[i+shift];
         if (max == EMPTY_VALUE) max = ma[i+shift];
      min = MathMin(min,ma[i+shift]);
      max = MathMax(max,ma[i+shift]);
   }
   else ma[i] = EMPTY_VALUE;
}


//+------------------------------------------------------------------+
//+                                                                  +
//+------------------------------------------------------------------+
//
//
//
//
//

void createLabel(string symbol,int element, int shift, bool signalCrossing)
{
   string name   = shortName+element;
   double price1 = 1;
   double price2 = 0;
   
   //
   //
   //
   //
   //
   
   if (ObjectFind(name) == -1)
      {
         ObjectCreate(name,OBJ_TEXT,window,0,0);
         ObjectSet(name,OBJPROP_ANGLE,90);
         ObjectSetText(name,symbol);
      }
      ObjectSet(name,OBJPROP_TIME1 ,Time[shift]);
      ObjectSet(name,OBJPROP_PRICE1,0.5);
      if (signalCrossing)
           ObjectSet(name,OBJPROP_COLOR,Gold);
      else ObjectSet(name,OBJPROP_COLOR,textColor);

   //
   //
   //
   //
   //

 
   name = shortName+element+element;
   if (ObjectFind(name) == -1)
      {
         ObjectCreate(name,OBJ_RECTANGLE,window,0,0,0,0);
         ObjectSet(name,OBJPROP_COLOR,backColor);
      }         
      ObjectSet(name,OBJPROP_TIME1,Time[shift]);
      ObjectSet(name,OBJPROP_PRICE1,price1);
      ObjectSet(name,OBJPROP_TIME2,Time[shift-(separatorWidth-2)]);
      ObjectSet(name,OBJPROP_PRICE2,price2);
}

//+------------------------------------------------------------------+
//+                                                                  +
//+------------------------------------------------------------------+
//
//
//
//
//


string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      char;
   
   while(lenght >= 0)
      {
         char = StringGetChar(s, lenght);
         
         //
         //
         //
         //
         //
         
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                  s = StringSetChar(s, lenght, char - 32);
          else 
              if(char > -33 && char < 0)
                  s = StringSetChar(s, lenght, char + 224);
                  
         //
         //
         //
         //
         //
                                 
         lenght--;
   }
   
   //
   //
   //
   //
   //
   
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string MakeUniqueName(string first, string rest)
{
   string result = first+(MathRand()%1001)+rest;

   while (WindowFind(result)> 0)
          result = first+(MathRand()%1001)+rest;
   return(result);
}
bool IsMini()
{
   if (StringFind(Symbol(),"m") > -1)
         return(true);
   else  return(false);    
}